<p align="center">
  <a href="https://nestpy.org/" target="blank"><img src="https://raw.githubusercontent.com/nestpy/docs.nestjs.org/830729b3530b3f55b70f174fda6a8839dc6d4612/public/img/nestpy.png" width="120" alt="NestPy Logo" /></a>
</p>

<p align="center">A progressive <a href="https://python.org" target="_blank">Python</a> framework for building efficient and scalable server-side applications.</p>

<p align="center">
    <a href="https://pypi.org/project/nestpy-framework">
        <img src="https://img.shields.io/pypi/v/nestpy-framework?color=%2334D058&label=pypi%20package" alt="Version">
    </a>
    <a href="https://pypi.org/project/nestpy-framework">
        <img src="https://img.shields.io/pypi/pyversions/nestpy-framework.svg?color=%2334D058" alt="Python">
    </a>
    <a href="https://pepy.tech/project/nestpy-framework">
        <img src="https://static.pepy.tech/personalized-badge/nestpy-framework?period=total&units=international_system&left_color=grey&right_color=brightgreen&left_text=Downloads" alt="Downloads">
    </a>
    <a href="https://github.com/nestpy/nest/blob/main/LICENSE">
        <img src="https://img.shields.io/github/license/nestpy/nest" alt="License">
    </a>
</p>

## Description

Nest (NestPy) is a framework for building efficient, scalable [Python](https://python.org/) server-side applications and combines elements of OOP (Object Oriented Programming), FP (Functional Programming), and FRP (Functional Reactive Programming).

Under the hood, Nest makes use of robust HTTP Server frameworks like [FastAPI](https://github.com/tiangolo/fastapi) (the default) and optionally can be configured to use [Flask](https://github.com/pallets/flask) (in development) as well!

Nest provides a level of abstraction above these common Python frameworks (FastAPI/Flask), but also exposes their APIs directly to the developer. This gives developers the freedom to use the myriad of third-party modules which are available for the underlying platform.

## Philosophy

Nest provides an out-of-the-box application architecture which allows developers and teams to create highly testable, scalable, loosely coupled, and easily maintainable applications. The architecture is heavily inspired by NestJS and Angular.

## Getting started

To get started with PyNest, you'll need to install it using pip:

```bash
pip install nestpy-framework
```

- To check out the [guide](https://docs.nestpy.org), visit [docs.nestpy.org](https://docs.nestpy.org). :books:

## Questions

For questions and support please use the official [Discord channel](). The issue list of this repo is **exclusively** for bug reports and feature requests.

## Issues

Please make sure to read the [Issue Reporting Checklist](https://github.com/nestpy/nest/issues) before opening an issue. Issues not conforming to the guidelines may be closed immediately.

## Support

Nest is an MIT-licensed open source project. It can grow thanks to the sponsors and support from the amazing backers. If you'd like to join them, please [read more here](https://docs.nestpy.org/support).

## Stay in touch

- Author - [Manuel S. Lemos](https://twitter.com/manuels_lemos)
- Website - [https://docs.nestjs.com](https://docs.nestjs.com/)

## License

Nest is [MIT licensed](LICENSE).
